;;; cmail-cfolder.el - cmail native folder interface module.

;; Author: Takeshi Morishima (tm@onepost.net)
;; Keywords: mail
;; Created at: Thu Oct 17 12:01:15 2002 UTC

;; This program is free software; you can redistribute it and/or
;; modify it under the terms of the GNU General Public License as
;; published by the Free Software Foundation; either version 2 of the
;; License, or (at your option) any later version.

;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
;; General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program; if not, write to the Free Software
;; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
;; USA

;;; Commentary:

;; This is a cmail module that handles native cmail folder.
;;
;;

(defvar *cmail-cfolder-mprop-cache nil)

(defun cmail-cfolder-get-mprop-alist (&optional folder)
  "cfolder ^tH_ FOLDER ̂炩ߍ쐬Ă郁bZ[W
AzXg (mprop-alist) Ԃ. (Xg͍ȂȂ. ̊֐͏
Ԃɂǂ邱Ƃ҂Ă) ߂l mprop-alist ͍
V̂̂Ɖ肳. "
  (save-excursion
    (cmail-get-folder folder)
    *cmail-cfolder-mprop-cache))

(defun cmail-cfolder-create-mprop-alist (&optional folder)
  "cfolder ^tH_ FOLDER ̃bZ[WAzXg (mprop-alist) 
쐬ĕԂ. ̊֐͏Ԃ̂ƂĈ. "
  (save-excursion
    (cmail-get-folder folder)
    (let ((fbuf (current-buffer)) beg end mprop mprop-cache)
      (goto-char (point-min))
      (setq beg (point-min))
      (re-search-forward *cmail-border)
      (setq end (point))
      (save-excursion
	(with-temp-buffer
	  (let ((tail-n (list 'mprop-alist)) (last (list 'indecies))) 
	    (erase-buffer)
	    (insert-buffer-substring fbuf beg end)
	    (decode-coding-region (point-min) (point-max)
				  *cmail-primary-coding-system)
	    (goto-char (point-min))
	  
	    (setq mprop-cache tail-n)
	    (setcdr mprop-cache (list last))
	    (setq tail-n (cdr tail-n))
	    (while (setq mprop (cmail-cfolder-parse-index-line))
	      (setcdr last (list (car mprop)))
	      (setq last (cdr last))
	      (setcdr tail-n (list mprop))
	      (setq tail-n (cdr tail-n))
	      (forward-line 1))))
	(setq *cmail-cfolder-mprop-cache mprop-cache))
      *cmail-cfolder-mprop-cache)))
  
(defun cmail-cfolder-parse-index-line ()
  "݃|C^s̃CfbNXs͂bZ[WAzX
g (mprop-alist) Ԃ. sɃ|C^邱ƁBp^[Ȃ
 nil Ԃ. ͂炩߃fR[hĂ邱ƁB"
  (if (looking-at cmail-summary-regexp)
      (let ((p (buffer-substring (match-beginning 1) (match-end 1)))
	    (S (buffer-substring (match-beginning 2) (match-end 2)))
	    (d (buffer-substring (match-beginning 3) (match-end 3)))
	    (n (buffer-substring (match-beginning 4) (match-end 4)))
	    (a (buffer-substring (match-beginning 5) (match-end 5)))
	    (l (buffer-substring (match-beginning 6) (match-end 6)))
	    (j (buffer-substring (match-beginning 7) (match-end 7))))
	(cons (string-to-int p)
	      (list (cons ?p p)
		    (cons ?s (if (string= S "A") " " S))
		    (cons ?d d)
		    (cons ?l (if (string= l "") "0" l))
		    (cons ?j j)
		    (cons ?n n)
		    (cons ?S S)
		    (cons ?a a))))))

(provide 'cmail-cfolder)
