#----------------------------------------------------------------------
# Namaham.pl  - a background service to perform namazu search for
#               Hamster IMAP4 server email through a TCP connection.
#               Created for cmail IMAP4 experimental search.
#

# Author: Takeshi Morishima (tm@onepost.net)
# Created at: Wed Dec 31 06:43:21 CST 2003

# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.

# How to use:
#
# Copy Namaham.ini.dist to Namaham.ini, modify it to match your
# environment.  Namazu Index must be built to perform search
# by using NamahamDbBld.pl.
#
# Easiest way to launch this program in background at start up
# time of Hamster is to use Hamster script and Automation features.
# NamahamStart.hsc is a sample Hamster script.  You can manually
# execute this script through Script pulldown menu and you can set
# up this to be exectued at start up time of Hamster through
# Management->Automation configuration setting.
#

open(I, 'Namaham.ini') || die('Cannot read Namaham.ini.  Also make sure working directory is set to topdir in Hamster.');
while (<I>) {
    s/;.*$//;
    if (/^(.*)=(.*)/) {
	$$1 = $2;
    }
}
close I;
for ($i = 1; $i < 32; $i++) {
    $var = 'User' . $i;
    $val = 'Secret' . $i;
    if ($$var) {
	if ($$val eq '') {
	    $secretlist{$$var} = 'nosecret';
	} else {
	    $secretlist{$$var} = $$val;
	}
    }
}

-d "./Mails" || die('Cannot find Mails directory in current working directory.');
-d $Namahamdbdir || die("Cannot find $Namahamdbdir directory.");
-f $Kanwadictpath || die("File $Kanwadictpath does not exist.  Please check Namaham.ini file.");
-f $Itaijidictpath || die("File $Itaijidictpath does not exist.  Please check Namaham.ini file.");
$NAMAZUOPTIONS[0]="--all";
$NAMAZUOPTIONS[1]="--list";

$ENV{'LANG'} = 'ja_JP.SJIS';
$ENV{'KANWADICTPATH'} = $Kanwadictpath;
$ENV{'ITAIJIDICTPATH'} = $Itaijidictpath;

$Namazupath =~ s/\\/\//g;

use IO::Socket;
use Digest::MD5 qw(md5_hex);
use NKF;

$sock = new IO::Socket::INET(Listen    => 5,
			     LocalAddr => 'localhost',
			     LocalPort => 50010,
			     Proto     => 'tcp');

while (1) {
    undef $line;
    undef $rcode;
    $sock->listen();
    $newsock = $sock->accept;
    $line = $newsock->getline();
    if ($line =~ /^[ \t\r\n]*([^ \t\r\n]+)[ \t\r\n]*$/) {
	$user = $1;
	$topdir = "Mails/" . $user;
	$secret = $secretlist{$user};
	if (-d $topdir && $secret ne '') {
	    $rcode = md5_hex(rand(1));
	    $newsock->write("+OK " . $rcode . "\r\n");
	    $line = $newsock->getline();
	    if ($line =~ /^([^ \t\r\n]+)[ \t\r\n]+\(.*\)[ \t\r\n]+(.*[^ \t\r\n])[ \t\r\n]*$/) {
		$hash = $1;
		$sstr = nkf("-s -J", $2);
		$makeup = md5_hex($rcode . $user . $secret . $rcode);
		if ($hash eq $makeup) {
		    $options = "@NAMAZUOPTIONS";
		    $idxdir = $Namahamdbdir . "/" . $user;
		    nmzsearch($newsock, $topdir, $options, $idxdir, $sstr);
		    $newsock->shutdown(2);
		} else {
		    $newsock->write("-NO Authentication failure.\r\n");
		    $newsock->shutdown(2);
		}
	    } else {
		$newsock->write("-NO Authentication failure.\r\n");
		$newsock->shutdown(2);
	    }
	} else {
	    $newsock->write("-NO A valid user name required.\r\n");
	    $newsock->shutdown(2);
	}
    } else {
	$newsock->write("-NO A valid user name required.\r\n");
	$newsock->shutdown(2);
    }
}

sub nmzsearch {
    ($s, $top, $options, $index, $str) = @_;
    print "$Namazupath $options \"$str\" $index \n";
    open(H, "$Namazupath $options \"$str\" $index |");
    while (<H>) {
	/^.*\/$top\/([0-9]+)\.msg/ && $s->write("$1 (/) INBOX\r\n");
	/^.*\/$top\/(.+)\/([0-9]+)\.msg/ && $s->write("$2 (/) $1\r\n");
    }
    $s->write("+OK\r\n");
    close H;
}
