#----------------------------------------------------------------------
# NamahamDbBld.pl  - a script to build Namazu Index for Hamster IMAP4
#                    server email for use by Namaham.pl program.
#                    Created for cmail IMAP4 experimental search.
#

# Author: Takeshi Morishima (tm@onepost.net)
# Created at: Wed Dec 31 06:43:21 CST 2003

# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.

# How to use:
#
# Copy Namaham.ini.dist to Namaham.ini, modify it to match your
# environment.  Run it like "perl using NamahamDbBld.pl" from
# command prompt to see if it exectutes without a problem.
#
# Easiest way to launch this program manually and periodically is 
# to use Hamster script and automation features.  NamahamDbBld.hsc
# is a sample Hamster script.  You can manually execute this script
# through Script pulldown menu and you can set up this to be
# exectued at scheduled time of Hamster through
# Management->Automation configuration setting.
#

open(I, 'Namaham.ini') || die('Cannot read Namaham.ini.  Also make sure working directory is set to topdir in Hamster.');
while (<I>) {
    s/;.*$//;
    if (/^(.*)=(.*)/) {
	$$1 = $2;
    }
}
close I;
for ($i = 1; $i < 32; $i++) {
    $var = 'User' . $i;
    if ($$var) {
	push @accounts, $$var;
    }
}

-d "./Mails" || die('Cannot find Mails directory in current working directory.');
-d $Namahamdbdir || mkdir $Namahamdbdir;
-d $Namahamdbdir || die("Cannot create $Namahamdbdir directory.");
-f $Kanwadictpath || die("File $Kanwadictpath does not exist.  Please check Namaham.ini file.");
-f $Itaijidictpath || die("File $Itaijidictpath does not exist.  Please check Namaham.ini file.");

use File::Find;

$ENV{'LANG'} = 'ja_JP.SJIS';
$ENV{'KANWADICTPATH'} = $Kanwadictpath;
$ENV{'ITAIJIDICTPATH'} = $Itaijidictpath;

use File::Find;

foreach $user (@accounts) {
    print "Building Namazu Index for user [$user]\n";

    $FINDTOPDIR = "Mails/" . $user;
    $INDEXDIR = $Namahamdbdir . "/" . $user;
    
    -d $FINDTOPDIR || goto ERR;
    -d $INDEXDIR || mkdir $INDEXDIR;
    -d $INDEXDIR || goto ERR;
    $NAMAHAMDBLIST = $INDEXDIR . '/NamahamDb.filelist';
    $MKNMZOPTIONS[0]="--all";
    $MKNMZOPTIONS[1]="--target-list=$NAMAHAMDBLIST";
    $MKNMZOPTIONS[2]="--output-dir=$INDEXDIR";
    $MKNMZOPTIONS[3]="--mailnews";
    
    @srcnames = ();

    find \&find_filter, $FINDTOPDIR;
    open(H, ">$NAMAHAMDBLIST");
    print H $_ . "\n" for @srcnames;
    close H;
    
    $cmd = "$Perlpath $Mknmzpath @MKNMZOPTIONS";
    $cmd =~ s/\\/\//g;
    print "$cmd\n";
    system($cmd);

    next;

ERR:
    print "Trouble in handling DB directory for user [$user]\n";
    next;
}
sleep(5);
exit 0;

sub find_filter {
    my $file = $File::Find::name;

    if ($file =~ /\.msg$/) {
	push @srcnames, $file;
    }
}
